/*
Copyright 2007-2024. Algoryx Simulation AB.

All AGX source code, intellectual property, documentation, sample code,
tutorials, scene files and technical white papers, are copyrighted, proprietary
and confidential material of Algoryx Simulation AB. You may not download, read,
store, distribute, publish, copy or otherwise disseminate, use or expose this
material unless having a written signed agreement with Algoryx Simulation AB, or having been
advised so by Algoryx Simulation AB for a time limited evaluation, or having purchased a
valid commercial license from Algoryx Simulation AB.

Algoryx Simulation AB disclaims all responsibilities for loss or damage caused
from using this software, unless otherwise stated in written agreements with
Algoryx Simulation AB.
*/
#pragma once

#include <agxSensor/RaytraceSystemNodeProxy.h>

namespace agxSensor
{
  AGX_DECLARE_POINTER_TYPES( LidarRayDistortion );
  using LidarRayDistortionRefVector = std::vector<LidarRayDistortionRef>;

  /**
  Superclass for distortions applied to the lidar rays before raytrace.
  */
  class AGXSENSOR_EXPORT LidarRayDistortion : public IRtSystemNode
  {
  public:
    DOXYGEN_START_INTERNAL_BLOCK()
    virtual RtNode* createNode() override;

    AGXSTREAM_DECLARE_SERIALIZABLE( agxSensor::LidarRayDistortion );

    DOXYGEN_END_INTERNAL_BLOCK()
  };

}
